const { registerPaymentMethod } = wc.wcBlocksRegistry;
const { createElement } = wp.element;
const { __ } = wp.i18n;

registerPaymentMethod({
    name: 'paybylink',
    label: __('Paybylink', 'paybylink-woocommerce'),
    ariaLabel: __('Paybylink Payment Gateway', 'paybylink-woocommerce'),
    supports: {
        showSavedCards: false, 
        tokenize: false,
    },
    content: createElement(
        'p',
        null,
        __('Zapłać wygodnie przez Paybylink', 'paybylink-woocommerce')
    ),
    edit: null,
    canMakePayment: function() {
        return true;
    },
    placeOrder: function() {
        return new Promise(function(resolve) {
            console.log('Placing order with Paybylink');
            resolve();
        });
    }
});


