<?php

class Paybylink_ITN_Handler 
{

    public function process_itn($key)
    {
        $response = file_get_contents('php://input');
        $response = json_decode($response, true);

        if(!isset($response['transactionId']) OR empty($response['transactionId'])) {
            echo 'not found transactionId';
            $error = true;
        }   

        if(!isset($response['control']) OR empty($response['control'])) {
            echo 'not found control';
            $error = true;
        }   

        if(!isset($response['email']) OR empty($response['email'])) {
            echo 'not found email';
            $error = true;
        }   

        if(!isset($response['amountPaid']) OR empty($response['amountPaid'])) {
            echo 'not found amountPaid';
            $error = true;
        }   

        if(!isset($response['notificationAttempt'])){
            echo 'not found notificationAttempt';
            $error = true;
        }  

        if(!isset($response['paymentType']) OR empty($response['paymentType'])) {
            echo 'not found paymentType';
            $error = true;
        }   

        if(!isset($response['apiVersion']) OR empty($response['apiVersion'])) {
            echo 'not found apiVersion';
            $error = true;
        }   

        if(!isset($error)) {
            $sign = sprintf("%s|%s|%s|%s|%.2f|%d|%s|%d", $key, $response['transactionId'], $response['control'], $response['email'], $response['amountPaid'], $response['notificationAttempt'], $response['paymentType'], $response['apiVersion']);

            if(hash('sha256', $sign) != $response['signature']) {  
                echo 'BAD SIGNATURE';
                $error = true;
            } else {    
                $order_id = explode("|", $response['control']);
                $order = wc_get_order($order_id[1]);
                if ($order->get_status() !== 'completed' && $order->get_status() !== 'processing') {
                    $order->payment_complete($response['transactionId']);
                    $order->add_order_note( __( 'Płatności Paybylink na kwotę ' . $response['amountPaid'] . ' PLN została przyjęta.', 'paybylink_payment' ) );
                }

                header("HTTP/2.0 200 OK");
                exit('OK');
            }
        }
    }

}
